Option Explicit On 
Option Strict On

Imports CrystalDecisions
Imports CrystalDecisions.Web
Imports CrystalDecisions.Shared
Imports CrystalDecisions.ReportSource
Imports CrystalDecisions.CrystalReports.Engine
Imports Microsoft
Imports System.Data.DataSet
Imports System.Data.OleDb
Imports System.Data.OleDb.OleDbType
Imports System.Data
Imports System.Xml
Imports System.Drawing.Printing
Imports System
Imports System.IO
Imports System.Data.Common.DbDataAdapter
Public Class WebForm11
    Inherits System.Web.UI.Page

#Region " Cdigo generado por el Diseador de Web Forms "

    'El Diseador de Web Forms requiere esta llamada.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents PanelImprimir As System.Web.UI.WebControls.Panel
    Protected WithEvents PanelExportar As System.Web.UI.WebControls.Panel
    Protected WithEvents PanelVisor As System.Web.UI.WebControls.Panel
    Protected WithEvents DropDownList1 As System.Web.UI.WebControls.DropDownList
    Protected WithEvents CrystalReportViewer1 As CrystalDecisions.Web.CrystalReportViewer
    Protected WithEvents PanelBotones As System.Web.UI.WebControls.Panel
    Protected WithEvents ddrptnomimp As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddrptoripapel As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddtamaopapel As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ddrptnumcop As System.Web.UI.WebControls.ListBox
    Protected WithEvents cmdImprimir As System.Web.UI.WebControls.Button
    Protected WithEvents cmdExportar As System.Web.UI.WebControls.Button
    Protected WithEvents cmdImprimir2 As System.Web.UI.WebControls.Button
    Protected WithEvents cmdCancelarImp As System.Web.UI.WebControls.Button
    Protected WithEvents cmdExportar2 As System.Web.UI.WebControls.Button
    Protected WithEvents cmdcancelarexp As System.Web.UI.WebControls.Button
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents Label2 As System.Web.UI.WebControls.Label
    Protected WithEvents chkrptintpag As System.Web.UI.WebControls.CheckBox
    Protected WithEvents Label3 As System.Web.UI.WebControls.Label
    Protected WithEvents Label4 As System.Web.UI.WebControls.Label
    Protected WithEvents Label5 As System.Web.UI.WebControls.Label
    Protected WithEvents Label6 As System.Web.UI.WebControls.Label
    Protected WithEvents txtdesdepag As System.Web.UI.WebControls.TextBox
    Protected WithEvents txthastapag As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtnomb_reportexport As System.Web.UI.WebControls.TextBox
    Protected WithEvents Label7 As System.Web.UI.WebControls.Label
    Protected WithEvents Label8 As System.Web.UI.WebControls.Label
    Protected WithEvents Label9 As System.Web.UI.WebControls.Label
    Protected WithEvents Label10 As System.Web.UI.WebControls.Label
    Protected WithEvents Label11 As System.Web.UI.WebControls.Label
    'NOTA: el Diseador de Web Forms necesita la siguiente declaracin del marcador de posicin.
    'No se debe eliminar o mover.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: el Diseador de Web Forms requiere esta llamada de mtodo
        'No la modifique con el editor de cdigo.

        With DropDownList1.Items
            .Add("Rich Text (RTF)")
            .Add("Portable Document (PDF)")
            .Add("MS Word (DOC)")
            .Add("MS Excel (XLS)")
            .Add("Crystal Report (RPT)")
            .Add("HTML 3.2 (HTML)")
            .Add("HTML 4.0 (HTML)")
        End With

        With ddtamaopapel.Items
            .Add("Predeterminado")
            .Add("Carta")
            .Add("Carta Pequeo")
            .Add("A4")
            .Add("A4 Corto")
            .Add("Ejecutivo")
            .Add("Legal")
        End With

        With ddrptoripapel.Items
            .Add("Predeterminado")
            .Add("Horizontal")
            .Add("Vertical")
        End With

        ddrptnumcop.Items.Item(0).Selected = True
        instalarimpresoras()
        InitializeComponent()
    End Sub
#End Region
    '   DECLARACIONES DE CONEXION

    Private crtablelogoninfos As New TableLogOnInfos
    Private crtablelogoninfo As New TableLogOnInfo
    Private crconnectioninfo As New ConnectionInfo
    Private crreportdocument As New ReportDocument
    Private imprimirdoc As New PrinterSettings
    Private crtables As Tables
    Private crtable As Table
    Private tablecounter As Integer
    Private inte As String

    '   DECLARACINES DE MARGEN
    Private margen As PageMargins

    '   DECLARACIONES DE EXPORTAR
    Private crDiskFileDestinationOptions As DiskFileDestinationOptions
    Private crExportOptions As ExportOptions


    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Introducir aqu el cdigo de usuario para inicializar la pgina

        rptservidor = "SERVIDOR" 'el nombre del servidor
        rptlogin = "sa" 'login de usuario que opera sabre la base de dats
        rptpassword = "odesis" ' contrasea del usuario
        rptnombd = "Northwind" ' nombre de la base de datos que vamos a utilizar

        rptnomb_tabla = "ejemplo" ' el nombre del procedimiento de almacenado...
        rptnomb_report = "reporte" ' el nombre del reporte

        rptdesde = "ALFKI" ' parametro desde donde comienza el filtrado del reporte
        rpthasta = "HANAR" ' parametro hasta donde termina el filtrado del reporte
        rptnomb_emp = "Empresa C.A." ' nombre del titulo del reporte... ejemplo la empresa

        rutarpt = Server.MapPath("reportes\" & rptnomb_report & ".rpt") ' indica la ruta en donde se encuentra el reporte dentro del directorio virutal

        crreportdocument.Load(rutarpt)  ' carga el reporque que indicamos en la ruta anterior

        crreportdocument.SetParameterValue("@desde", rptdesde) 'asigna el parametro de inicio del filtrado al reporte
        crreportdocument.SetParameterValue("@hasta", rpthasta) 'asigna el parametro de final del filtrado al reporte
        crreportdocument.SetParameterValue("nomb_empresa", rptnomb_emp) ' 'asigna el parametro del nombre de la empresa al reporte



        '   CAMBIA LA CONEXION DE LA BASE DE DATOS
        Dim crTables As CrystalDecisions.CrystalReports.Engine.Tables  ' declaracion de una variable de tipo tablas
        Dim crTable As CrystalDecisions.CrystalReports.Engine.Table ' declaracion de una variable de tipo tabla
        Dim crConnInfo As New CrystalDecisions.Shared.ConnectionInfo ' declaracion de una variable de tipo connectioninfo para el reportdocument
        Dim crLogOnInfo As CrystalDecisions.Shared.TableLogOnInfo '' declaracion de una variable de tipo connectioninfo para la tabla

        crTables = crreportdocument.Database.Tables  ' abreviacion de codigo....
        For Each crTable In crTables
            crConnInfo.DatabaseName = rptnombd ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de datos
            crConnInfo.ServerName = rptservidor ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base del servidor
            crConnInfo.UserID = rptlogin  ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de usuario
            crConnInfo.Password = rptpassword ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de contrasea
            crLogOnInfo = crTable.LogOnInfo ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de las tablas
            crLogOnInfo.ConnectionInfo = crConnInfo ' asigna al connectioninfo, que es la misma informacion de conexion del reporte
            crTable.ApplyLogOnInfo(crLogOnInfo) ' asigna al connectioninfo, que es la misma informacion de conexion, el nombre de la base de la tabla
        Next
        CrystalReportViewer1.ReportSource = crreportdocument ' indica la direccion del reporte en el visor

        CrystalReportViewer1.DataBind() ' ejecuta la carga del reporte al visor
        aplicarmargen() ' aplica los margenes al visor
        ActivarPanel("PanelVisor") ' activa el panel del visor y esconde los dems paneles
    End Sub
    Private Sub cmdCancelarImp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancelarImp.Click
        ActivarPanel("PanelVisor")
    End Sub

    Private Sub cmdcancelexpor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ActivarPanel("PanelVisor")
    End Sub

    Private Sub ddrptnomimp_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If ddrptnomimp.SelectedIndex <> -1 Then
            rptimpresora = ddrptnomimp.SelectedValue  ' selecciona la impresora que est en el selected value del ddrptnomimp
        End If
    End Sub
    Private Sub ddrptnumcop_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)

        If ddrptnomimp.SelectedIndex <> -1 Then
            rptnumerocopia = CType(ddrptnumcop.SelectedValue, Integer) ' indica los numero de copias que queremos por pagina
        End If
    End Sub

    Private Sub ddrptnumcop_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ddrptnumcop.SelectedIndexChanged
        If ddrptnumcop.SelectedIndex > 0 Then
            chkrptintpag.Enabled = True
        Else
            chkrptintpag.Enabled = False
        End If
        rptnumerocopia = CType(ddrptnumcop.SelectedValue, Integer)
    End Sub
    Private Sub instalarimpresoras()
        ' Add list of installed printers found to the combo box.
        ' The pkInstalledPrinters string will be used to provide the display string.
        Dim i As Integer
        Dim pkInstalledPrinters As String
        For i = 0 To PrinterSettings.InstalledPrinters.Count - 1
            pkInstalledPrinters = PrinterSettings.InstalledPrinters(i)
            ddrptnomimp.Items.Add(pkInstalledPrinters)
        Next
    End Sub
    Private Sub ActivarPanel(ByVal panel As String)
        Select Case panel
            Case Is = "PanelImprimir" ' oculta el panel del visor y botones para visualizar el panel de imprimir
                PanelImprimir.Visible = True
                PanelVisor.Visible = False
                PanelExportar.Visible = False
                PanelBotones.Visible = False
            Case Is = "PanelExportar"
                PanelImprimir.Visible = False
                PanelVisor.Visible = False
                PanelExportar.Visible = True
                PanelBotones.Visible = False
            Case Is = "PanelVisor"
                PanelImprimir.Visible = False
                PanelVisor.Visible = True
                PanelExportar.Visible = False
                PanelBotones.Visible = True
        End Select
    End Sub
    Private Sub ExportarReporte()
        rptnomb_reportexport = txtnomb_reportexport.Text ' asigna el nombre del reporte exportado que se encuentra en la caja de texto

        '   VERIFICAMOS SI EL NOMBRE NO ESTA VACO
        If Trim(rptnomb_reportexport) = "" Then
            Response.Write("ATENCIN: Debe introducir el nombre del reporte que desea exportar")
        Else

            '   INDICAMOS LA RUTA DE EXPORTACION
            rptExportPath = Request.PhysicalApplicationPath + "Reportes Exportados\"


            '   CREAR UNA NUEVA EXPORTACION DE ARCHIVO A DISCO
            crDiskFileDestinationOptions = New DiskFileDestinationOptions


            '   SIMPLIFICACION DE CODIGO, ESTE SE HACE PARA EVITAR ESCRIVIR MUCHAS VECES crreportdocument.ExportOptions.....
            crExportOptions = crreportdocument.ExportOptions


            '   SELECCIONAMOS LA OPCION ELEGIDA DEL DROPDOWNLIST1, QUE INDICA EL FORMATO QUE QUEREMOS EXPORTAR
            Select Case DropDownList1.SelectedItem.Text

                '   FORMATO "RTF"
            Case "Rich Text (RTF)"
                    crDiskFileDestinationOptions.DiskFileName = rptExportPath + rptnomb_reportexport + ".rtf" ' Nombre del archivo a exportar

                    With crreportdocument.ExportOptions
                        .ExportDestinationType = ExportDestinationType.DiskFile ' tipo de exportacion
                        .ExportFormatType = ExportFormatType.RichText ' formato de exportacion
                        .DestinationOptions = crDiskFileDestinationOptions 'opcion de destiono de exportacion
                    End With
                    rptFname = rptnomb_reportexport + ".rtf" ' nombre de reporte con la extencion... se realiza para que despues de exportado ejecute el response.redirec...
                    rptdirreport_export = "Reportes Exportados\" ' directorio virtual donde van a estar los reportes exportados

                    '   FORMATO "PDF"
                Case "Portable Document (PDF)"
                    crDiskFileDestinationOptions.DiskFileName = rptExportPath + rptnomb_reportexport + ".pdf"
                    With crExportOptions
                        .DestinationOptions = crDiskFileDestinationOptions
                        .ExportDestinationType = ExportDestinationType.DiskFile
                        .ExportFormatType = ExportFormatType.PortableDocFormat
                    End With
                    rptFname = rptnomb_reportexport + ".pdf"
                    rptdirreport_export = "Reportes Exportados\"

                    '   FORMATO "DOC"
                Case "MS Word (DOC)"
                    crDiskFileDestinationOptions.DiskFileName = rptExportPath + rptnomb_reportexport + ".doc"
                    With crreportdocument.ExportOptions
                        .ExportDestinationType = ExportDestinationType.DiskFile
                        .ExportFormatType = ExportFormatType.WordForWindows
                        .DestinationOptions = crDiskFileDestinationOptions
                    End With
                    rptFname = rptnomb_reportexport + ".doc"
                    rptdirreport_export = "Reportes Exportados\"

                    '   FORMATO "XLS"
                Case "MS Excel (XLS)"
                    crDiskFileDestinationOptions.DiskFileName = rptExportPath + rptnomb_reportexport + ".xls"
                    With crreportdocument.ExportOptions
                        .ExportDestinationType = ExportDestinationType.DiskFile
                        .ExportFormatType = ExportFormatType.Excel
                        .DestinationOptions = crDiskFileDestinationOptions
                    End With
                    rptFname = rptnomb_reportexport + ".xls"
                    rptdirreport_export = "Reportes Exportados\"


                    '   FORMATO "RPT"
                Case "Crystal Report (RPT)"
                    crDiskFileDestinationOptions.DiskFileName = rptExportPath + rptnomb_reportexport + ".rpt"
                    With crreportdocument.ExportOptions
                        .ExportDestinationType = ExportDestinationType.DiskFile
                        .ExportFormatType = ExportFormatType.CrystalReport
                        .DestinationOptions = crDiskFileDestinationOptions
                    End With
                    rptFname = rptnomb_reportexport + ".rpt"
                    rptdirreport_export = "Reportes Exportados\"

                    '   FORMATO "HTML"
                Case "HTML 3.2 (HTML)"
                    Dim HTML32Formatopts As New HTMLFormatOptions
                    With crExportOptions
                        .ExportDestinationType = ExportDestinationType.DiskFile
                        .ExportFormatType = ExportFormatType.HTML32
                    End With

                    With HTML32Formatopts
                        .HTMLBaseFolderName = rptExportPath + "Html32"
                        .HTMLFileName = rptnomb_reportexport + ".html"
                        .HTMLEnableSeparatedPages = False
                        .HTMLHasPageNavigator = False
                    End With
                    crExportOptions.FormatOptions = HTML32Formatopts

                    rptFname = rptnomb_reportexport + ".htm"
                    rptdirreport_export = "Reportes Exportados\Html32\" + rptnomb_report + "\"

                    '   FORMATO "HTML"
                Case "HTML 4.0 (HTML)"
                    Dim HTML40Formatopts As New HTMLFormatOptions
                    With crExportOptions
                        .ExportDestinationType = ExportDestinationType.DiskFile
                        .ExportFormatType = ExportFormatType.HTML40
                    End With

                    With HTML40Formatopts
                        .HTMLBaseFolderName = rptExportPath + "Html40"
                        .HTMLFileName = rptnomb_reportexport + ".html"
                        .HTMLEnableSeparatedPages = True
                        .HTMLHasPageNavigator = True
                        .FirstPageNumber = 1
                        .LastPageNumber = 3
                    End With
                    crExportOptions.FormatOptions = HTML40Formatopts

                    rptFname = rptnomb_reportexport + ".htm"
                    rptdirreport_export = "Reportes Exportados\Html40\" + rptnomb_report + "\"
            End Select

            '   INDICA EL NOMBRE DEL ARCHIVO A EXPORTAR
            Try

                '   EXPORTA EL REPORTE Y LO ABRE, REDIRECCIONANDOLO
                crreportdocument.Export()
                Response.Redirect(rptdirreport_export & System.IO.Path.GetFileName(rptFname)) ' abre el reporte exportado

            Catch err As Exception
                Response.Write("<BR>")
                Response.Write(err.Message.ToString) ' escribe el mensaje de error si llega a ocurrir alguno
            End Try
        End If
    End Sub
    Private Sub aplicarmargen()

        margen = crreportdocument.PrintOptions.PageMargins ' margen de la pagina
        margen.bottomMargin = 350   'MARGEN INFERIOR
        margen.topMargin = 350   'MARGEN SUPERIOR
        margen.leftMargin = 350     'MARGEN IZQUIERDA
        margen.rightMargin = 350   'MARGEN DERECHA
        ' APLICA LOS MARGENES AL REPORTE
        crreportdocument.PrintOptions.ApplyPageMargins(margen) ' aplica lo margenes

    End Sub
    Private Sub asigimpresion()

        'Selecciona todo lo que est en las cajas de texto

        ddrptnumcop.SelectedItem.Selected = True
        ddrptnomimp.SelectedItem.Selected = True
        ddrptoripapel.SelectedItem.Selected = True
        ddtamaopapel.SelectedItem.Selected = True

        'Indica el tamao del papel
        Select Case ddtamaopapel.SelectedValue
            Case Is = "Predeterminado"
                rpttamaopapel = crreportdocument.PrintOptions.PaperSize.DefaultPaperSize
            Case Is = "Carta"
                rpttamaopapel = crreportdocument.PrintOptions.PaperSize.PaperLetter
            Case Is = "Carta Pequeo"
                rpttamaopapel = crreportdocument.PrintOptions.PaperSize.PaperLetterSmall
            Case Is = "A4"
                rpttamaopapel = crreportdocument.PrintOptions.PaperSize.PaperA4
            Case Is = "A4 Corto"
                rpttamaopapel = crreportdocument.PrintOptions.PaperSize.PaperA4Small
            Case Is = "Ejecutivo"
                rpttamaopapel = crreportdocument.PrintOptions.PaperSize.PaperExecutive
            Case Is = "Legal"
                rpttamaopapel = crreportdocument.PrintOptions.PaperSize.PaperLegal
        End Select

        ' Si el check esta activado intercala las pginas
        If chkrptintpag.Checked = False Then
            rptintercalarp = False
        Else
            rptintercalarp = True
        End If

        'INDICA EL NOMBRE DE LA IMPRESORA

        crreportdocument.PrintOptions.PrinterName = rptimpresora

        'INDICA EL TAMAO DEL PAPEL
        crreportdocument.PrintOptions.PaperSize = rpttamaopapel

        'INDICA LA ORIENTACION DEL PAPEL
        Select Case ddrptoripapel.SelectedValue
            Case Is = "Predeterminado"
                crreportdocument.PrintOptions.PaperOrientation = PaperOrientation.DefaultPaperOrientation
            Case Is = "Horizontal"
                crreportdocument.PrintOptions.PaperOrientation = PaperOrientation.Landscape
            Case Is = "Vertical"
                crreportdocument.PrintOptions.PaperOrientation = PaperOrientation.Portrait
        End Select

        If (rptintercalarp = True) And (CType(ddrptnumcop.SelectedValue, Integer) = 1) Then
            Response.Write("No se puede intercalar una sola pgina")
        Else
            rptimpresora = ddrptnomimp.SelectedValue
            rptdesdepagina = CType(txtdesdepag.Text, Integer)
            rpthastapagina = CType(txthastapag.Text, Integer)
            rptnumerocopia = CType(ddrptnumcop.SelectedValue, Integer)
            rptnumerocopia = CType(ddrptnumcop.SelectedValue, Integer)
            inte = "Next"
        End If


    End Sub

    Private Sub cmdImprimir2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdImprimir2.Click
        Try
            aplicarmargen()

            asigimpresion()
            If inte = "Next" Then

                'ENVIA EL REPORTDOCUMENT A LA IMPRESION
                crreportdocument.PrintToPrinter(rptnumerocopia, rptintercalarp, rptdesdepagina, rpthastapagina)
                ActivarPanel("PanelVisor")

            Else
                ActivarPanel("PanelImprimir")
            End If
        Catch err As Exception
            Response.Write("<BR>")
            Response.Write(err.Message.ToString)
        End Try
    End Sub
    Private Sub cmdImprimir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdImprimir.Click
        ActivarPanel("PanelImprimir")
    End Sub
    Private Sub cmdExportar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExportar.Click
        ActivarPanel("PanelExportar")
    End Sub

    Private Sub cmdcancelarexp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdcancelarexp.Click
        ActivarPanel("PanelVisor")
    End Sub

    Private Sub cmdExportar2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExportar2.Click
        ExportarReporte()
    End Sub
End Class



